From 940a61a5b3abfd218936eba9300129a32a2c5fd5 Mon Sep 17 00:00:00 2001
From: Santhosh S <sants@codeaurora.org>
Date: Thu, 5 Mar 2020 11:46:26 +0530
Subject: [PATCH] pulsedirectsink : Fix audio glitches when you do
 pa_stream_write

- With pa_stream_write buffers are rendered by calculating the
  offset at which it has to be rendered in a pulseaudio stream
  and do ABSOLUTE rendering. Calculation of this offset was based
  on the samples w.r.t basetime and current running time which
  resulted in a fraction and had to be ceiled properly.
---
 ext/pulse/pulsedirectsink.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/ext/pulse/pulsedirectsink.c b/ext/pulse/pulsedirectsink.c
index 1722c45..8db8108 100644
--- a/ext/pulse/pulsedirectsink.c
+++ b/ext/pulse/pulsedirectsink.c
@@ -554,7 +554,7 @@ gst_pulsedirectsink_calc_offset (GstPulseDirectSink * psink,
   base_time = gst_element_get_base_time (GST_ELEMENT (psink));
 
   samples =
-      gst_util_uint64_scale (base_time + running_time, psink->rate, GST_SECOND);
+      gst_util_uint64_scale_round (base_time + running_time, psink->rate, GST_SECOND);
   ret = samples * psink->bpf;
 
   GST_LOG_OBJECT (psink, "calculated offset: %" G_GINT64_FORMAT, ret);
-- 
2.21.0

